// Copyright 2023 Xanadu Quantum Technologies Inc.

// Licensed under the Apache License, Version 2.0 (the "License");
// you may not use this file except in compliance with the License.
// You may obtain a copy of the License at

//     http://www.apache.org/licenses/LICENSE-2.0

// Unless required by applicable law or agreed to in writing, software
// distributed under the License is distributed on an "AS IS" BASIS,
// WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
// See the License for the specific language governing permissions and
// limitations under the License.
/**
 * @file
 * Include all AVX gate implementations
 */
#pragma once
#include "../GatePragmas.hpp"
#include "ApplyCNOT.hpp"
#include "ApplyCRX.hpp"
#include "ApplyCRY.hpp"
#include "ApplyCRZ.hpp"
#include "ApplyCY.hpp"
#include "ApplyCZ.hpp"
#include "ApplyControlledPhaseShift.hpp"
#include "ApplyGeneratorIsingXX.hpp"
#include "ApplyGeneratorIsingYY.hpp"
#include "ApplyGeneratorIsingZZ.hpp"
#include "ApplyGeneratorPhaseShift.hpp"
#include "ApplyHadamard.hpp"
#include "ApplyIsingXX.hpp"
#include "ApplyIsingXY.hpp"
#include "ApplyIsingYY.hpp"
#include "ApplyIsingZZ.hpp"
#include "ApplyPauliX.hpp"
#include "ApplyPauliY.hpp"
#include "ApplyPauliZ.hpp"
#include "ApplyPhaseShift.hpp"
#include "ApplyRX.hpp"
#include "ApplyRY.hpp"
#include "ApplyRZ.hpp"
#include "ApplyS.hpp"
#include "ApplySWAP.hpp"
#include "ApplySingleQubitOp.hpp"
#include "ApplyT.hpp"
